searchNodes=[{"ref":"AMQP.html","title":"AMQP","type":"module","doc":"This module provides AMQP-related types."},{"ref":"AMQP.html#t:argument_type/0","title":"AMQP.argument_type/0","type":"type","doc":""},{"ref":"AMQP.html#t:arguments/0","title":"AMQP.arguments/0","type":"type","doc":""},{"ref":"AMQP.Basic.html","title":"AMQP.Basic","type":"module","doc":"Functions to publish, consume and acknowledge messages."},{"ref":"AMQP.Basic.html#ack/3","title":"AMQP.Basic.ack/3","type":"function","doc":"Acknowledges one or more messages. Options :multiple - If set, all messages up to the one specified by delivery_tag are acknowledged. Defaults to false."},{"ref":"AMQP.Basic.html#cancel/3","title":"AMQP.Basic.cancel/3","type":"function","doc":"Stops the given consumer from consuming. This method cancels a consumer. This does not affect already delivered messages, but it does mean the server will not send any more messages for that consumer. The client may receive an arbitrary number of messages in between sending the cancel method and receiving the reply. consumer_tag identifies the &quot;subscription&quot; to cancel, that is, the subscription of a consumer to a specific queue. The consumer tag is returned by consume/4. Options :no_wait - If set, the cancel operation is asynchronous. Defaults to false."},{"ref":"AMQP.Basic.html#cancel_return/1","title":"AMQP.Basic.cancel_return/1","type":"function","doc":"Removes the return handler, if it exists. Does nothing if there is no such handler."},{"ref":"AMQP.Basic.html#consume/4","title":"AMQP.Basic.consume/4","type":"function","doc":"Registers a queue consumer process. The pid of the process can be set using the consumer_pid argument and defaults to the calling process. The consumer process will receive the following data structures: {:basic_deliver, payload, meta} - This is sent for each message consumed, where payload contains the message content and meta contains all the metadata set when sending with Basic.publish or additional info set by the broker; {:basic_consume_ok, %{consumer_tag: consumer_tag}} - Sent when the consumer process is registered with Basic.consume. The caller receives the same information as the return of Basic.consume; {:basic_cancel, %{consumer_tag: consumer_tag, no_wait: no_wait}} - Sent by the broker when the consumer is unexpectedly cancelled (such as after a queue deletion) {:basic_cancel_ok, %{consumer_tag: consumer_tag}} - Sent to the consumer process after a call to Basic.cancel Options :consumer_tag - Specifies the consumer tag for this consumer (as a string). This tag is local to the given channel chan, so different channels can have consumers that use the same consumer tag. If the given consumer tag is &quot;&quot;, then the server autogenerates the tag. Defaults to &quot;&quot;. :no_local - If set, the server won&#39;t send messages to the connection that published them. Defaults to false. :no_ack - If set, the server will not expect message acks from the consumer and will consider every message that it believes was delivered to the consumer as acknowledged. Defaults to false, meaning that messages need to be acked explicitly through ack/3. :exclusive - If set, requests exclusive consumer access, meaning that only this consumer can consume from the given queue. Note that the client cannot have exclusive access to a queue that already has consumers. :no_wait - If set, the consume operation is asynchronous. Defaults to false. :arguments - A list of arguments to pass when consuming (of type AMQP.arguments/0). See the README for more information. Defaults to []."},{"ref":"AMQP.Basic.html#get/3","title":"AMQP.Basic.get/3","type":"function","doc":"Polls a queue for an existing message. Returns the tuple {:empty, meta} if the queue is empty or the tuple {:ok, payload, meta} if at least one message exists in the queue. The returned meta map includes the entry :message_count with the current number of messages in the queue. Receiving messages by polling a queue is not as as efficient as subscribing a consumer to a queue, so consideration should be taken when receiving large volumes of messages. Options :no_ack - If set, the broker is told that the received will not send an acknoledgement of the message. Once the broker believes it has delivered the message, then it&#39;s free to assume that the consuming application has taken responsibility for it. In general, a lot of applications will not want these semantics, rather, they will want to explicitly acknowledge the receipt of a message (through ack/3). Defaults to false (meaning explicit acks)."},{"ref":"AMQP.Basic.html#nack/3","title":"AMQP.Basic.nack/3","type":"function","doc":"Negative acknowledges of one or more messages. This is a RabbitMQ specific extension to AMQP 0.9.1. It is equivalent to reject/3, but allows rejecting multiple messages using the multiple option. Options :multiple - If set, all messages up to the one specified by delivery_tag are considered as not acknowledged by the server. Defaults to false. :requeue - If set, the message will be returned to the queue and redelivered to the next available consumer. Defaults to true."},{"ref":"AMQP.Basic.html#publish/5","title":"AMQP.Basic.publish/5","type":"function","doc":"Publishes a message to an Exchange. This method publishes a message to a specific exchange. The message will be routed to queues as defined by the exchange configuration and distributed to any subscribers. The parameter exchange specifies the name of the exchange to publish to. If set to empty string, it publishes to the default exchange. The routing_key parameter specifies the routing key for the message. The payload parameter specifies the message content as a binary. In addition to the previous parameters, the following options can be used: Options :mandatory - If set, returns an error if the broker can&#39;t route the message to a queue (default false); :immediate - If set, returns an error if the broker can&#39;t deliver the message to a consumer immediately (default false); :content_type - MIME Content type; :content_encoding - MIME Content encoding; :headers - Message headers of type AMQP.arguments/0. Can be used with headers Exchanges; :persistent - If set, uses persistent delivery mode. Messages marked as persistent that are delivered to durable queues will be logged to disk; :correlation_id - application correlation identifier; :priority - message priority, ranging from 0 to 9; :reply_to - name of the reply queue; :expiration - how long the message is valid (in milliseconds); :message_id - message identifier; :timestamp - timestamp associated with this message (epoch time); :type - message type as a string; :user_id - creating user ID. RabbitMQ will validate this against the active connection user; :app_id - publishing application ID. Examples iex&gt; AMQP.Basic.publish chan, &quot;my_exchange&quot;, &quot;my_routing_key&quot;, &quot;Hello World!&quot;, persistent: true :ok"},{"ref":"AMQP.Basic.html#qos/2","title":"AMQP.Basic.qos/2","type":"function","doc":"Sets the message prefetch count or prefetech size (in bytes). Options :prefetch_size - the prefetch size (in bytes). Defaults to 0. :prefetch_count - the prefetch count. Defaults to 0. :global - If set, this applies to the entire Connection, otherwise it applies only to the given Channel. Defaults to false."},{"ref":"AMQP.Basic.html#recover/2","title":"AMQP.Basic.recover/2","type":"function","doc":"Asks the server to redeliver all unacknowledged messages on a specified channel. Options :requeue - If set, the server will attempt to requeue the message, potentially delivering it to another subscriber. Otherwise it will be redelivered to the original recipient. Defaults to false."},{"ref":"AMQP.Basic.html#reject/3","title":"AMQP.Basic.reject/3","type":"function","doc":"Rejects (and, optionally, requeues) a message. Options :requeue - If set, the message is requeued by the server, otherwise it&#39;s discarded. Defaults to true."},{"ref":"AMQP.Basic.html#return/2","title":"AMQP.Basic.return/2","type":"function","doc":"Registers a handler to deal with returned messages. The registered process will receive {:basic_return, payload, meta} tuples."},{"ref":"AMQP.Basic.html#t:consumer_tag/0","title":"AMQP.Basic.consumer_tag/0","type":"type","doc":""},{"ref":"AMQP.Basic.html#t:delivery_tag/0","title":"AMQP.Basic.delivery_tag/0","type":"type","doc":""},{"ref":"AMQP.Basic.html#t:error/0","title":"AMQP.Basic.error/0","type":"type","doc":""},{"ref":"AMQP.Basic.html#t:exchange/0","title":"AMQP.Basic.exchange/0","type":"type","doc":""},{"ref":"AMQP.Basic.html#t:payload/0","title":"AMQP.Basic.payload/0","type":"type","doc":""},{"ref":"AMQP.Basic.html#t:queue/0","title":"AMQP.Basic.queue/0","type":"type","doc":""},{"ref":"AMQP.Basic.html#t:routing_key/0","title":"AMQP.Basic.routing_key/0","type":"type","doc":""},{"ref":"AMQP.BasicError.html","title":"AMQP.BasicError","type":"exception","doc":"Raised when the connection is closed or blocked."},{"ref":"AMQP.Channel.html","title":"AMQP.Channel","type":"module","doc":"Functions to operate on Channels."},{"ref":"AMQP.Channel.html#close/1","title":"AMQP.Channel.close/1","type":"function","doc":"Closes an open Channel."},{"ref":"AMQP.Channel.html#open/1","title":"AMQP.Channel.open/1","type":"function","doc":"Opens a new Channel in a previously opened Connection."},{"ref":"AMQP.Channel.html#t:t/0","title":"AMQP.Channel.t/0","type":"type","doc":""},{"ref":"AMQP.Confirm.html","title":"AMQP.Confirm","type":"module","doc":"Functions that work with publisher confirms (RabbitMQ extension to AMQP 0.9.1)."},{"ref":"AMQP.Confirm.html#next_publish_seqno/1","title":"AMQP.Confirm.next_publish_seqno/1","type":"function","doc":"On channel with confirm activated, return the next message sequence number. To use in combination with register_handler/2"},{"ref":"AMQP.Confirm.html#register_handler/2","title":"AMQP.Confirm.register_handler/2","type":"function","doc":"Register a handler for confirms on channel. The handler will receive either: {:basic_ack, seqno, multiple} {:basic_nack, seqno, multiple} The seqno (delivery_tag) is an integer, the sequence number of the message. multiple is a boolean, when true means multiple messages confirm, upto seqno. see https://www.rabbitmq.com/confirms.html"},{"ref":"AMQP.Confirm.html#select/1","title":"AMQP.Confirm.select/1","type":"function","doc":"Activates publishing confirmations on the channel."},{"ref":"AMQP.Confirm.html#unregister_handler/1","title":"AMQP.Confirm.unregister_handler/1","type":"function","doc":"Remove the return handler. It does nothing if there is no such handler."},{"ref":"AMQP.Confirm.html#wait_for_confirms/1","title":"AMQP.Confirm.wait_for_confirms/1","type":"function","doc":"Wait until all messages published since the last call have been either ack&#39;d or nack&#39;d by the broker."},{"ref":"AMQP.Confirm.html#wait_for_confirms/2","title":"AMQP.Confirm.wait_for_confirms/2","type":"function","doc":"Wait until all messages published since the last call have been either ack&#39;d or nack&#39;d by the broker, or until timeout elapses."},{"ref":"AMQP.Confirm.html#wait_for_confirms_or_die/1","title":"AMQP.Confirm.wait_for_confirms_or_die/1","type":"function","doc":"Wait until all messages published since the last call have been either ack&#39;d or nack&#39;d by the broker, or until timeout elapses. If any of the messages were nack&#39;d, the calling process dies."},{"ref":"AMQP.Confirm.html#wait_for_confirms_or_die/2","title":"AMQP.Confirm.wait_for_confirms_or_die/2","type":"function","doc":""},{"ref":"AMQP.Connection.html","title":"AMQP.Connection","type":"module","doc":"Functions to operate on Connections."},{"ref":"AMQP.Connection.html#close/1","title":"AMQP.Connection.close/1","type":"function","doc":"Closes an open Connection."},{"ref":"AMQP.Connection.html#open/1","title":"AMQP.Connection.open/1","type":"function","doc":"Opens a new connection without a name. Behaves exactly like open(options_or_uri, :undefined). See open/2."},{"ref":"AMQP.Connection.html#open/2","title":"AMQP.Connection.open/2","type":"function","doc":"Opens an new Connection to an AMQP broker. The connections created by this module are supervised under amqp_client&#39;s supervision tree. Please note that connections do not get restarted automatically by the supervision tree in case of a failure. If you need robust connections and channels, use monitors on the returned connection PID. This function can be called in three ways: with a list of options and a name with an AMQP URI and a name with an AMQP URI and a list of options (in this case, the options are merged with the AMQP URI, taking precedence on same keys) Options :username - The name of a user registered with the broker (defaults to &quot;guest&quot;); :password - The password of user (defaults to &quot;guest&quot;); :virtual_host - The name of a virtual host in the broker (defaults to &quot;/&quot;); :host - The hostname of the broker (defaults to &quot;localhost&quot;); :port - The port the broker is listening on (defaults to 5672); :channel_max - The channel_max handshake parameter (defaults to 0); :frame_max - The frame_max handshake parameter (defaults to 0); :heartbeat - The hearbeat interval in seconds (defaults to 10); :connection_timeout - The connection timeout in milliseconds (defaults to 50000); :ssl_options - Enable SSL by setting the location to cert files (defaults to :none); :client_properties - A list of extra client properties to be sent to the server, defaults to []; :socket_options - Extra socket options. These are appended to the default options. See http://www.erlang.org/doc/man/inet.html#setopts-2 and http://www.erlang.org/doc/man/gen_tcp.html#connect-4 for descriptions of the available options. Enabling SSL To enable SSL, supply the following in the ssl_options field: cacertfile - Specifies the certificates of the root Certificate Authorities that we wish to implicitly trust; certfile - The client&#39;s own certificate in PEM format; keyfile - The client&#39;s private key in PEM format; Example AMQP.Connection.open port: 5671, ssl_options: [cacertfile: &#39;/path/to/testca/cacert.pem&#39;, certfile: &#39;/path/to/client/cert.pem&#39;, keyfile: &#39;/path/to/client/key.pem&#39;, # only necessary with intermediate CAs # depth: 2, verify: :verify_peer, fail_if_no_peer_cert: true] Connection name RabbitMQ supports user-specified connection names since version 3.6.2. Connection names are human-readable strings that will be displayed in the management UI. Connection names do not have to be unique and cannot be used as connection identifiers. If the name is :undefined, the connection is not registered with any name. Examples iex&gt; options = [host: &quot;localhost&quot;, port: 5672, virtual_host: &quot;/&quot;, username: &quot;guest&quot;, password: &quot;guest&quot;] iex&gt; AMQP.Connection.open(options, :undefined) {:ok, %AMQP.Connection{}} iex&gt; AMQP.Connection.open(&quot;amqp://guest:guest@localhost&quot;, port: 5673) {:ok, %AMQP.Connection{}} iex&gt; AMQP.Connection.open(&quot;amqp://guest:guest@localhost&quot;, &quot;a-connection-with-a-name&quot;) {:ok, %AMQP.Connection{}}"},{"ref":"AMQP.Connection.html#open/3","title":"AMQP.Connection.open/3","type":"function","doc":"Opens a new connection with a name, merging the given AMQP URI and options. This function opens a new connection by merging the given AMQP URI uri and the given options and assigns it the name name. The options in options take precedence over the values in uri. See open/2 for options. Examples iex&gt; AMQP.Connection.open(&quot;amqp://guest:guest@localhost&quot;, &quot;a-connection-name&quot;, port: 5673) {:ok, %AMQP.Connection{}}"},{"ref":"AMQP.Connection.html#t:t/0","title":"AMQP.Connection.t/0","type":"type","doc":""},{"ref":"AMQP.Exchange.html","title":"AMQP.Exchange","type":"module","doc":"Functions to operate on Exchanges."},{"ref":"AMQP.Exchange.html#bind/4","title":"AMQP.Exchange.bind/4","type":"function","doc":"Binds an Exchange to another Exchange using the exchange.bind AMQP method (a RabbitMQ-specific extension). Options :routing_key - the routing key to use for the binding. Defaults to &quot;&quot;. :no_wait - If set, the bind operation is asynchronous. Defaults to false. :arguments - A list of arguments to pass when binding (of type AMQP.arguments/0). See the README for more information. Defaults to []."},{"ref":"AMQP.Exchange.html#declare/4","title":"AMQP.Exchange.declare/4","type":"function","doc":"Declares an Exchange. The default Exchange type is direct. AMQP 0-9-1 brokers provide four pre-declared exchanges: :direct exchange: (empty string) or amq.direct :fanout exchange: amq.fanout :topic exchange: amq.topic :headers exchange: amq.match (and amq.headers in RabbitMQ) Besides the exchange name and type, the following options can be used: Options :durable - If set, keeps the Exchange between restarts of the broker; :auto_delete - If set, deletes the Exchange once all queues unbind from it; :passive - If set, returns an error if the Exchange does not already exist; :internal - If set, the exchange may not be used directly by publishers, but only when bound to other exchanges. Internal exchanges are used to construct wiring that is not visible to applications. :no_wait - If set, the declare operation is asynchronous. Defaults to false. :arguments - A list of arguments to pass when declaring (of type AMQP.arguments/0). See the README for more information. Defaults to []."},{"ref":"AMQP.Exchange.html#delete/3","title":"AMQP.Exchange.delete/3","type":"function","doc":"Deletes an Exchange by name. When an Exchange is deleted all bindings to it are also deleted. Options :if_unused - If set, the server will only delete the exchange if it has no queue bindings. :no_wait - If set, the delete operation is asynchronous. Defaults to false."},{"ref":"AMQP.Exchange.html#direct/3","title":"AMQP.Exchange.direct/3","type":"function","doc":"Convenience function to declare an Exchange of type direct. Options This function takes the same options as declare/4."},{"ref":"AMQP.Exchange.html#fanout/3","title":"AMQP.Exchange.fanout/3","type":"function","doc":"Convenience function to declare an Exchange of type fanout. Options This function takes the same options as declare/4."},{"ref":"AMQP.Exchange.html#topic/3","title":"AMQP.Exchange.topic/3","type":"function","doc":"Convenience function to declare an Exchange of type topic. Options This function takes the same options as declare/4."},{"ref":"AMQP.Exchange.html#unbind/4","title":"AMQP.Exchange.unbind/4","type":"function","doc":"Unbinds an Exchange from another Exchange or a Queue using the exchange.unbind AMQP method (a RabbitMQ-specific extension). Options :routing_key - the routing key to use for the binding. Defaults to &quot;&quot;. :no_wait - If set, the declare operation is asynchronous. Defaults to false. :arguments - A list of arguments to pass when declaring (of type AMQP.arguments/0). See the README for more information. Defaults to []."},{"ref":"AMQP.Queue.html","title":"AMQP.Queue","type":"module","doc":"Functions to operate on Queues."},{"ref":"AMQP.Queue.html#bind/4","title":"AMQP.Queue.bind/4","type":"function","doc":"Binds a Queue to an Exchange. Options :routing_key - The routing key used to bind the queue to the exchange. Defaults to &quot;&quot;. :no_wait - If true, the binding is not synchronous. Defaults to false. :arguments - A list of arguments to pass when binding (of type AMQP.arguments/0). See the README for more information. Defaults to []."},{"ref":"AMQP.Queue.html#consumer_count/2","title":"AMQP.Queue.consumer_count/2","type":"function","doc":"Returns a number of active consumers on the queue."},{"ref":"AMQP.Queue.html#declare/3","title":"AMQP.Queue.declare/3","type":"function","doc":"Declares a queue. The optional queue parameter is used to set the name. If set to an empty string (default), the server will assign a name. Besides the queue name, the following options can be used: Options :durable - If set, keeps the Queue between restarts of the broker. Defaults to false. :auto_delete - If set, deletes the Queue once all subscribers disconnect. Defaults to false. :exclusive - If set, only one subscriber can consume from the Queue. Defaults to false. :passive - If set, raises an error unless the queue already exists. Defaults to false. :no_wait - If set, the declare operation is asynchronous. Defaults to false. :arguments - A list of arguments to pass when declaring (of type AMQP.arguments/0). See the README for more information. Defaults to []."},{"ref":"AMQP.Queue.html#delete/3","title":"AMQP.Queue.delete/3","type":"function","doc":"Deletes a Queue by name. Options :if_unused - If set, the server will only delete the queue if it has no consumers. If the queue has consumers, it&#39;s not deleted and an error is returned. :if_empty - If set, the server will only delete the queue if it has no messages. :no_wait - If set, the delete operation is asynchronous."},{"ref":"AMQP.Queue.html#empty?/2","title":"AMQP.Queue.empty?/2","type":"function","doc":"Returns true if queue is empty (has no messages ready), false otherwise."},{"ref":"AMQP.Queue.html#message_count/2","title":"AMQP.Queue.message_count/2","type":"function","doc":"Returns the number of messages that are ready for delivery (e.g. not pending acknowledgements) in the queue."},{"ref":"AMQP.Queue.html#purge/2","title":"AMQP.Queue.purge/2","type":"function","doc":"Discards all messages in the Queue."},{"ref":"AMQP.Queue.html#status/2","title":"AMQP.Queue.status/2","type":"function","doc":"Returns the message count and consumer count for the given queue. Uses declare/3 with the :passive option set."},{"ref":"AMQP.Queue.html#subscribe/3","title":"AMQP.Queue.subscribe/3","type":"function","doc":"Convenience to consume messages from a Queue. The handler function must have arity 2 and will receive as arguments a binary with the message payload and a Map with the message properties. The consumed message will be acknowledged after executing the handler function. If an exception is raised by the handler function, the message is rejected. This convenience function will spawn a process and register it using AMQP.Basic.consume."},{"ref":"AMQP.Queue.html#unbind/4","title":"AMQP.Queue.unbind/4","type":"function","doc":"Unbinds a Queue from an Exchange. Options :routing_key - The routing queue for removing the binding. Defaults to &quot;&quot;. :arguments - A list of arguments to pass when unbinding (of type AMQP.arguments/0). See the README for more information. Defaults to []."},{"ref":"AMQP.Queue.html#unsubscribe/2","title":"AMQP.Queue.unsubscribe/2","type":"function","doc":"Stops the consumer identified by consumer_tag from consuming. Internally just calls AMQP.Basic.cancel/2."},{"ref":"readme.html","title":"AMQP","type":"extras","doc":"AMQP Simple Elixir wrapper for the Erlang RabbitMQ client. The API is based on Langohr, a Clojure client for RabbitMQ."},{"ref":"readme.html#migration-from-0-x-to-1-x","title":"AMQP - Migration from 0.X to 1.X","type":"extras","doc":"If you use amqp 0.X and plan to migrate to 1.0 please read our migration guide."},{"ref":"readme.html#usage","title":"AMQP - Usage","type":"extras","doc":"Add AMQP as a dependency in your mix.exs file. def deps do [ {:amqp, &quot;~&gt; 1.3&quot;} ] end Elixir will start amqp automatically with this if you use Elixir 1.6+. If that&#39;s not the case (use Application.started_applications/0 to check), try adding :amqp to applications or extra_applications in your mix.exs. Or call Application.ensure_started(:amqp) at the start. After you are done, run mix deps.get in your shell to fetch and compile AMQP. Start an interactive Elixir shell with iex -S mix. iex&gt; {:ok, conn} = AMQP.Connection.open() # {:ok, %AMQP.Connection{pid: #PID&lt;0.165.0&gt;}} iex&gt; {:ok, chan} = AMQP.Channel.open(conn) # {:ok, %AMQP.Channel{conn: %AMQP.Connection{pid: #PID&lt;0.165.0&gt;}, pid: #PID&lt;0.177.0&gt;} iex&gt; AMQP.Queue.declare(chan, &quot;test_queue&quot;) # {:ok, %{consumer_count: 0, message_count: 0, queue: &quot;test_queue&quot;}} iex&gt; AMQP.Exchange.declare(chan, &quot;test_exchange&quot;) # :ok iex&gt; AMQP.Queue.bind(chan, &quot;test_queue&quot;, &quot;test_exchange&quot;) # :ok iex&gt; AMQP.Basic.publish(chan, &quot;test_exchange&quot;, &quot;&quot;, &quot;Hello, World!&quot;) # :ok iex&gt; {:ok, payload, meta} = AMQP.Basic.get(chan, &quot;test_queue&quot;) iex&gt; payload # &quot;Hello, World!&quot; iex&gt; AMQP.Queue.subscribe(chan, &quot;test_queue&quot;, fn payload, _meta -&gt; IO.puts(&quot;Received: \#{payload}&quot;) end) # {:ok, &quot;amq.ctag-5L8U-n0HU5doEsNTQpaXWg&quot;} iex&gt; AMQP.Basic.publish(chan, &quot;test_exchange&quot;, &quot;&quot;, &quot;Hello, World!&quot;) # :ok # Received: Hello, World! Setup a consumer GenServer defmodule Consumer do use GenServer use AMQP def start_link do GenServer.start_link(__MODULE__, [], []) end @exchange &quot;gen_server_test_exchange&quot; @queue &quot;gen_server_test_queue&quot; @queue_error &quot;\#{@queue}_error&quot; def init(_opts) do {:ok, conn} = Connection.open(&quot;amqp://guest:guest@localhost&quot;) {:ok, chan} = Channel.open(conn) setup_queue(chan) # Limit unacknowledged messages to 10 :ok = Basic.qos(chan, prefetch_count: 10) # Register the GenServer process as a consumer {:ok, _consumer_tag} = Basic.consume(chan, @queue) {:ok, chan} end # Confirmation sent by the broker after registering this process as a consumer def handle_info({:basic_consume_ok, %{consumer_tag: consumer_tag}}, chan) do {:noreply, chan} end # Sent by the broker when the consumer is unexpectedly cancelled (such as after a queue deletion) def handle_info({:basic_cancel, %{consumer_tag: consumer_tag}}, chan) do {:stop, :normal, chan} end # Confirmation sent by the broker to the consumer process after a Basic.cancel def handle_info({:basic_cancel_ok, %{consumer_tag: consumer_tag}}, chan) do {:noreply, chan} end def handle_info({:basic_deliver, payload, %{delivery_tag: tag, redelivered: redelivered}}, chan) do # You might want to run payload consumption in separate Tasks in production consume(chan, tag, redelivered, payload) {:noreply, chan} end defp setup_queue(chan) do {:ok, _} = Queue.declare(chan, @queue_error, durable: true) # Messages that cannot be delivered to any consumer in the main queue will be routed to the error queue {:ok, _} = Queue.declare(chan, @queue, durable: true, arguments: [ {&quot;x-dead-letter-exchange&quot;, :longstr, &quot;&quot;}, {&quot;x-dead-letter-routing-key&quot;, :longstr, @queue_error} ] ) :ok = Exchange.fanout(chan, @exchange, durable: true) :ok = Queue.bind(chan, @queue, @exchange) end defp consume(channel, tag, redelivered, payload) do number = String.to_integer(payload) if number &lt;= 10 do :ok = Basic.ack channel, tag IO.puts &quot;Consumed a \#{number}.&quot; else :ok = Basic.reject channel, tag, requeue: false IO.puts &quot;\#{number} is too big and was rejected.&quot; end rescue # Requeue unless it&#39;s a redelivered message. # This means we will retry consuming a message once in case of exception # before we give up and have it moved to the error queue # # You might also want to catch :exit signal in production code. # Make sure you call ack, nack or reject otherwise comsumer will stop # receiving messages. exception -&gt; :ok = Basic.reject channel, tag, requeue: not redelivered IO.puts &quot;Error converting \#{payload} to integer&quot; end end iex&gt; Consumer.start_link {:ok, #PID&lt;0.261.0&gt;} iex&gt; {:ok, conn} = AMQP.Connection.open {:ok, %AMQP.Connection{pid: #PID&lt;0.165.0&gt;}} iex&gt; {:ok, chan} = AMQP.Channel.open(conn) {:ok, %AMQP.Channel{conn: %AMQP.Connection{pid: #PID&lt;0.165.0&gt;}, pid: #PID&lt;0.177.0&gt;} iex&gt; AMQP.Basic.publish chan, &quot;gen_server_test_exchange&quot;, &quot;&quot;, &quot;5&quot; :ok Consumed a 5. iex&gt; AMQP.Basic.publish chan, &quot;gen_server_test_exchange&quot;, &quot;&quot;, &quot;42&quot; :ok 42 is too big and was rejected. iex&gt; AMQP.Basic.publish chan, &quot;gen_server_test_exchange&quot;, &quot;&quot;, &quot;Hello, World!&quot; :ok Error converting Hello, World! to integer Error converting Hello, World! to integer"},{"ref":"readme.html#stable-rabbitmq-connection","title":"AMQP - Stable RabbitMQ Connection","type":"extras","doc":"While the above example works, it does nothing to handle RabbitMQ connection outages. In case of an outage your Genserver will remain stale and won&#39;t receive any messages from the broker as the connection is never restarted. Luckily, implementing a reconnection logic is quite straight forward. Since the connection record holds the pid of the connection itself, we can monitor it and get a notification when it goes down. Example implementation: defmodule MyApp.AMQP do use GenServer require Logger alias AMQP.Connection @host &quot;amqp://localhost&quot; @reconnect_interval 10_000 def start_link(opts \\\\ [name: __MODULE__]) do GenServer.start_link(__MODULE__, nil, opts) end def init(_) do send(self(), :connect) {:ok, nil} end def get_connection do case GenServer.call(__MODULE__, :get) do nil -&gt; {:error, :not_connected} conn -&gt; {:ok, conn} end end def handle_call(:get, _, conn) do {:reply, conn, conn} end def handle_info(:connect, conn) do case Connection.open(@host) do {:ok, conn} -&gt; # Get notifications when the connection goes down Process.monitor(conn.pid) {:noreply, conn} {:error, _} -&gt; Logger.error(&quot;Failed to connect \#{@host}. Reconnecting later...&quot;) # Retry later Process.send_after(self(), :connect, @reconnect_interval) {:noreply, nil} end end def handle_info({:DOWN, _, :process, _pid, reason}, _) do # Stop GenServer. Will be restarted by Supervisor. {:stop, {:connection_lost, reason}, nil} end end Now, when the server starts, it will try to reconnect indefinitely until it succeeds. When the connection drops or the server is down, the GenServer will stop. If you have put the GenServer module to your application tree, the Supervisor will automatically restart it. Then it will try to reconnect indefinitely until it succeeds."},{"ref":"readme.html#types-of-arguments-and-headers","title":"AMQP - Types of arguments and headers","type":"extras","doc":"The parameter arguments in Queue.declare, Exchange.declare, Basic.consume and the parameter headers in Basic.publish are a list of tuples in the form {name, type, value}, where name is a binary containing the argument/header name, type is an atom describing the AMQP field type and value a term compatible with the AMQP field type. The valid AMQP field types are: :longstr | :signedint | :decimal | :timestamp | :table | :byte | :double | :float | :long | :short | :bool | :binary | :void | :array Valid argument names in Queue.declare include: &quot;x-expires&quot; &quot;x-message-ttl&quot; &quot;x-dead-letter-routing-key&quot; &quot;x-dead-letter-exchange&quot; &quot;x-max-length&quot; &quot;x-max-length-bytes&quot; Valid argument names in Basic.consume include: &quot;x-priority&quot; &quot;x-cancel-on-ha-failover&quot; Valid argument names in Exchange.declare include: &quot;alternate-exchange&quot;"},{"ref":"readme.html#troubleshooting-faq","title":"AMQP - Troubleshooting / FAQ","type":"extras","doc":"Connections and Channels If this is your first time using RabbitMQ, we recommend you to start designing your application like this way: Open and manage a single connection for an application Open/close a channel per process (don&#39;t share a channel between multiple processes) Once you saw things in action you can now consider optimising the performance by increasing number of connections etc. Note it&#39;s completely safe to share a single connection between multiple processes. However it is not recommended to share a channel between multiple processes. It&#39;s technically possible but you want to understand the implications when you do. Make sure you close the channel after used to avoid any potential memory leaks and warnings from RabbitMQ client library. Consumer stops receiving messages It usually happens when your code doesn&#39;t send acknowledgement(ack, nack or reject) after receiving a message. You want to investigate if... an exception was raised and how it would be handled :exit signal was thrown and how it would be handled a message processing took long time. If you use GenServer in consumer, try storing number of messages the server is currently processing to the GenServer state. If the number equals prefetch_count, those messages were left without acknowledgements and that&#39;s why consumer have stopped receiving more messages. What are Elixir, OTP and RabbitMQ versions supported? Please see this wiki article for the details. Heartbeats In case the connection is dropped automatically, consider enabling heartbeats. You can set heartbeat option when you open a connection. For more details, read this article Log related to amqp supervisors are too verbose Try the following configuration. config :logger, handle_otp_reports: false Or try filtering out the messages at your application start: :logger.add_primary_filter( :ignore_rabbitmq_progress_reports, {&amp;:logger_filters.domain/2, {:stop, :equal, [:progress]}} ) See this comment for the details. Lager conflicts with Elixir logger Lager is used by rabbit_common and it is not Elixir&#39;s best friend yet. You need a workaround. In mix.exs, you have to load :lager before :logger. extra_applications: [:lager, :logger, :amqp] Here is a sample configuration to silent rabbit_common logging. config :lager, error_logger_redirect: false, handlers: [level: :critical] Check out Lager and RabbitMQ documentation for more information. Compile error on ranch_proxy_protocol with OTP 21 Update amqp to 1.1.0 or a greater version. Does the library support AMQP 1.0? Currently the library doesn&#39;t support AMQP 1.0 and there is no plan to do so at the moment. Our main aim here (at least for now) is to provide a thin wrapper around amqp_client for Elixir programmers."}]